#ifndef ISCSI_ATTR_H_
#define ISCSI_ATTR_H_

/*
 * iSCSI driver for Linux
 * Copyright (C) 2002 Cisco Systems, Inc.
 * maintained by linux-iscsi-devel@lists.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * See the file COPYING included with this distribution for more details.
 *
 * $Id: iscsi-attr.h,v 1.1.2.5 2003/12/31 05:34:11 naveenb Exp $
 *
 */

#include <linux/inet.h>
#include "iscsi-version.h"
#include "iscsi.h"

extern struct iscsi_hba *iscsi_hba;

#ifdef ATTR_DEBUG
extern struct class_device_attribute lun_ignore;
extern struct class_device_attribute lun_reject;
extern struct class_device_attribute lun_busy;
extern struct class_device_attribute lun_queuefull;
extern struct class_device_attribute lun_unreachable;
extern struct class_device_attribute lun_abort;
extern struct class_device_attribute lun_tasktimeout;
extern struct class_device_attribute lun_cmndtimeout;
extern struct class_device_attribute lun_status;
extern struct class_device_attribute target_ignore;
extern struct class_device_attribute target_reject;
extern struct class_device_attribute target_busy;
extern struct class_device_attribute target_queuefull;
extern struct class_device_attribute target_unreachable;
extern struct class_device_attribute target_abort;
extern struct class_device_attribute target_nop;
extern struct class_device_attribute logout_session;
extern struct class_device_attribute target_portal;
extern struct class_device_attribute target_drop;
extern struct class_device_attribute target_queues;
extern struct class_device_attribute target_notready;
extern struct class_device_attribute target_reset;
extern struct class_device_attribute writedatamismatch;
extern struct class_device_attribute writeheadermismatch;
extern struct class_device_attribute readdatamismatch;
extern struct class_device_attribute target_cmndtimeouts;
extern struct class_device_attribute target_tasktimeouts;
extern struct class_device_attribute target_tasktimeout;
extern struct class_device_attribute target_cmdtimeout;
extern struct class_device_attribute session_terminate;
extern struct class_device_attribute target_printcmnd;
extern struct class_device_attribute target_txcmnd;
extern struct class_device_attribute target_retry;
#endif

extern struct class_device_attribute log_status;
extern struct class_device_attribute shutdown;
extern struct class_device_attribute change_portal;
extern struct class_device_attribute print_info;
extern struct class_device_attribute host_id;
extern struct class_device_attribute network_boot;

struct class_device_attribute *iscsi_host_attrs[] = {
	&log_status,
	&shutdown,
	&change_portal,
	&print_info,
	&host_id,
	&network_boot,
#ifdef ATTR_DEBUG
	&lun_ignore,
	&lun_reject,
	&lun_busy,
	&lun_queuefull,
	&lun_unreachable,
	&lun_abort,
	&lun_tasktimeout,
	&lun_cmndtimeout,
	&lun_status,
	&target_ignore,
	&target_reject,
	&target_busy,
	&target_queuefull,
	&target_unreachable,
	&target_nop,
	&logout_session,
	&target_portal,
	&target_drop,
	&target_queues,
	&target_notready,
	&target_abort,
	&target_reset,
	&target_tasktimeout,
	&target_cmdtimeout,
	&session_terminate,
	&target_printcmnd,
	&target_txcmnd,
	&target_retry,
	&target_tasktimeouts,
	&target_cmndtimeouts,
	&writeheadermismatch,
	&readdatamismatch,
	&writedatamismatch,
#endif
	NULL,
};
#endif
