#ifndef ISCSI_IO_H_
#define ISCSI_IO_H_

/*
 * iSCSI driver for Linux
 * Copyright (C) 2002 Cisco Systems, Inc.
 * maintained by linux-iscsi-devel@lists.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * See the file COPYING included with this distribution for more details.
 *
 * $Id: iscsi-io.h,v 1.2.12.3 2003/12/16 05:59:52 smhatre Exp $
 *
 * iscsi-io.h
 *
 *   define the PDU I/O functions needed by the login library
 * 
 */

# include "iscsi-session.h"

extern int iscsi_connect(struct iscsi_session *session);
extern void iscsi_disconnect(struct iscsi_session *session);

/* functions used in iscsi-login.c that must be implemented for each platform */
extern int iscsi_send_pdu(struct iscsi_session *session,
			  struct IscsiHdr *header, char *data, int timeout);
extern int iscsi_recv_pdu(struct iscsi_session *session,
			  struct IscsiHdr *header, int max_header_length,
			  char *data, int max_data_length, int timeout);

#endif
