#! /bin/sh

OLD=${ROOT}/etc/NuScsiTcp.conf
NEW=${ROOT}/etc/iscsi.conf

# temp files used to build /etc/iscsi.conf
IPADDRS=/tmp/$$.iscsi.ipaddr
TARGETLUNS=/tmp/$$.iscsi.targetluns
ISCSICONF=/tmp/$$.iscsi.conf

trap "rm -f $IPADDRS $TARGETLUNS $ISCSICONF" 0 2 3 15

if [ -f $OLD ] ; then
    echo "Updating $NEW based on $OLD"
    egrep '^[ \t]*TargetIpAddr=' $OLD | sed -e 's|TargetIpAddr=|DiscoveryAddress=|' > $IPADDRS
    egrep '^[ \t]*Target,Lun=' $OLD > $TARGETLUNS
    # insert DiscoveryAddresses after the last example DiscoveryAddress
    sed -e "/^# DiscoveryAddress=/{
	    N
	    /^# DiscoveryAddress=.*\n[ 	]*$/r $IPADDRS
	    }" ./iscsi.conf > $ISCSICONF
    # insert Target,Luns after the last example Target,Lun
    sed -e "/^# Target,Lun=/{
	    N 
	    /^# Target,Lun=.*\n[ 	]*$/r $TARGETLUNS
	    }" $ISCSICONF > $NEW

    rm -f $IPADDRS $TARGETLUNS $ISCSICONF
fi

exit 0
