#ifndef IVTV_COMPAT_H
#define IVTV_COMPAT_H

#include <linux/kernel.h>
#include <linux/version.h>

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 0)
#define LINUX26 1
#ifndef NEW_I2C
#define NEW_I2C
#endif
#endif

/* Mmm, 2.6 doesn't know about this one... */
#ifndef V4L2_CAP_RADIO
#define V4L2_CAP_RADIO          0x00040000  /* is a radio device */
#endif

#ifndef LINUX26
#define i2c_get_clientdata(client)   ((client)->data)
#define i2c_set_clientdata(client,y) ((client)->data = (y))
#define i2c_get_adapdata(adap)       ((adap)->data);
#define i2c_set_adapdata(adap,y)     ((adap)->data = (y));

#include <linux/slab.h>
#include <linux/videodev.h>

static inline struct video_device *video_device_alloc(void)
{
	struct video_device *vfd;

	vfd = kmalloc(sizeof(*vfd),GFP_KERNEL);
	if (NULL == vfd)
		return NULL;
	memset(vfd,0,sizeof(*vfd));
	return vfd;
}

static inline void video_device_release(struct video_device *vfd)
{
	kfree(vfd);
}

#define IRQ_NONE
#define IRQ_HANDLED
#define IRQRETURN_T void
#else
#define IRQRETURN_T irqreturn_t
#endif

#ifndef __KERNEL_SYSCALLS__
#define __KERNEL_SYSCALLS__
#endif

#endif
