/*
 *
 *    Copyright 1995-1999 Regents of the University of Minnesota
 *    Portions Copyright 1999-2001 Sistina Software, Inc.
 *    Portions Copyright 2003 The OpenGFS Project
 *
 *    This is free software released under the GNU General Public License.
 *    There is no warranty for this software.  See the file COPYING for
 *    details.
 *
 *    See the file AUTHORS for a list of contributors.
 *
 */

/*
 * Dio structures specific to Linux
 */
#ifndef _DIO_ARCH_H
#define _DIO_ARCH_H

/*  Generic struct buffer_head info
    Take care with BH_BUFDATA(), it's a cheat.  */

#define BH_DATA(bh) ((char *)(bh)->b_data)
#define BH_BLKNO(bh) ((uint64)(bh)->b_blocknr)
#define BH_SIZE(bh) ((uint32)(bh)->b_size)
#define BH_BUFDATA(bh) ((ogfs_bufdata_t *)(bh)->b_private)

/*  Buffer head list functions  */

void ogfs_inval_bh(ogfs_sbd_t * sdp, ogfs_glock_t * gl);
void ogfs_sync_bh(ogfs_sbd_t * sdp, ogfs_glock_t * gl, int wait);
void ogfs_free_bh(ogfs_sbd_t * sdp, ogfs_glock_t * gl);

#endif /* _DIO_ARCH_H */
