/*
 *
 *    Copyright 1995-1999 Regents of the University of Minnesota
 *    Portions Copyright 2001 Sistina Software, Inc.
 *
 *    This is free software released under the GNU General Public License.
 *    There is no warranty for this software.  See the file COPYING for
 *    details.
 *
 *    See the file AUTHORS for a list of contributors.
 *
 */
#ifndef _DIR_H
#define _DIR_H

/*  Directory translation function  */

typedef int (*ogfs_filldir_t) (void *opaque,
			      const char *name, unsigned int length,
			      uint64 offset, uint64 inode, unsigned type);

int ogfs_filecmp(struct qstr * file1, char *file2, loff_t len_of_file2);
int ogfs_dirent_alloc(ogfs_inode_t * dip, struct buffer_head * bh, int name_len,
		     ogfs_dirent_t ** dent_out);

int ogfs_dir_search(ogfs_inode_t * dip, struct qstr * filename, ogfs_inum_t * inum,
		   unsigned int *type);
int ogfs_dir_add(ogfs_inode_t * dip, struct qstr * filename, ogfs_inum_t * inum,
		unsigned int type);
int ogfs_dir_del(ogfs_inode_t * dip, struct qstr * filename);
int ogfs_dir_read(ogfs_inode_t * dip, int64 * f_pos, void *dirent,
		 ogfs_filldir_t filldir);
int ogfs_dir_mvino(ogfs_inode_t * dip, struct qstr * filename,
		  ogfs_inum_t * new_inum, unsigned int new_type);

int ogfs_dir_exhash_free(ogfs_inode_t * dip);

#endif /* _DIR_H */
