/*
 *
 *    Copyright 1995-2000 Regents of the University of Minnesota
 *    Portions Copyright 1999-2001 Sistina Software, Inc.
 *
 *    This is free software released under the GNU General Public License.
 *    There is no warranty for this software.  See the file COPYING for
 *    details.
 *
 *    See the file AUTHORS for a list of contributors.
 *
 */

/*
 * The OGFS architecture dependent incore structures.
 */
#ifndef _INCORE_ARCH_H
#define _INCORE_ARCH_H

struct ogfs_bufdata_arch {
	struct list_head bd_list;	/* Keeps list of buffers */

	unsigned int bd_pinned;	/* Pin count */

	ogfs_trans_t *bd_ail_tr;	/* This buffer is in this AIL transaction */
	struct list_head bd_ail_list;	/* List of buffers hanging off tr_bufs */
};
typedef struct ogfs_bufdata_arch ogfs_bufdata_arch_t;

struct ogfs_glock_arch {
	struct list_head gl_bufs;	/* Buffer list for caching */
};
typedef struct ogfs_glock_arch ogfs_glock_arch_t;

struct ogfs_trans_arch {
	struct list_head tr_bufs;	/* AIL buffers */
};
typedef struct ogfs_trans_arch ogfs_trans_arch_t;

#endif /* _INCORE_ARCH_H */
