/*
 *
 *    Copyright 1999-2001 Sistina Software, Inc.
 *
 *    This is free software released under the GNU General Public License.
 *    There is no warranty for this software.  See the file COPYING for
 *    details.
 *
 *    See the file AUTHORS for a list of contributors.
 *
 */

/*
 *          What rolls down stairs
 *             Alone or in pairs
 *      Rolls over your neighbor's dog.
 *         What's great for a snack
 *           And fits on your back
 *             It's log, log, log!
 *             It's lo-og, lo-og,
 *       It's big, it's heavy, it's wood.
 *             It's lo-og, lo-og,
 *       It's better than bad, it's good.
 *           Everyone wants a log,
 *         You're gonna love it, log
 *         Come on and get your log,
 *           Everyone needs a log...
 *            LOG... FROM BLAMMO!
 *
 *                     -- The Ren and Stimpy Show
 */
#ifndef _LOG_H
#define _LOG_H

void ogfs_nopen_merge(ogfs_sbd_t * sdp, ogfs_tr_nop_t * nop_new,
		     struct list_head * list, atomic_t * counter);
void ogfs_nopen_find(ogfs_sbd_t * sdp, ogfs_inum_t * inum);

void ogfs_nopen_dump(ogfs_sbd_t * sdp, int force);

int ogfs_log_reserv(ogfs_sbd_t * sdp, unsigned int segments);
void ogfs_log_relse(ogfs_sbd_t * sdp, unsigned int segments);
void ogfs_pull_tail(ogfs_sbd_t * sdp);

void ogfs_log_commit(ogfs_sbd_t * sdp, ogfs_trans_t * trans);
void ogfs_log_flush(ogfs_sbd_t * sdp, ogfs_glock_t * gl);

int ogfs_shutdown_log(ogfs_sbd_t * sdp);

unsigned int ogfs_struct2blk(ogfs_sbd_t * sdp, unsigned int nstruct,
			    unsigned int ssize);
unsigned int ogfs_blk2seg(ogfs_sbd_t * sdp, unsigned int blocks);

#endif /* _LOG_H */
