/*
 *
 *    Copyright 1995-1999 Regents of the University of Minnesota
 *    Portions Copyright 2000-2001 Sistina Software, Inc.
 *
 *    This is free software released under the GNU General Public License.
 *    There is no warranty for this software.  See the file COPYING for
 *    details.
 *
 *    See the file AUTHORS for a list of contributors.
 *
 */
#ifndef _LVB_H
#define _LVB_H

struct ogfs_rgrp_save {
	uint32 rs_magic;

	uint32 rs_free;		/* Caching RG usage data */
	uint32 rs_useddi;
	uint32 rs_freedi;
	uint32 rs_usedmeta;
	uint32 rs_freemeta;
	uint16 rs_owner;	/* JID of owner + 1 */
};
typedef struct ogfs_rgrp_save ogfs_rgrp_save_t;

struct plock_element_s {
	uint64 begin;
	uint64 end;
	uint32 magic;		/* PLel */
	uint32 pid;
	uint16 Next;
	uint8 ltype;
};
typedef struct plock_element_s plock_element_t;
#define PLOCK_ELEM_MAGIC 0x504C656C

struct plock_jid_head_s {
	uint32 magic;		/* PLjh */
	uint32 lock_group;
	uint16 lock_count;
	uint16 first;
};
typedef struct plock_jid_head_s plock_jid_head_t;
#define PLOCK_JID_HEAD_MAGIC 0x504C6A68

struct plock_head_s {
	uint32 magic;		/* PLCK */
	uint32 Jid_group;
};
typedef struct plock_head_s plock_head_t;
#define PLOCK_HEAD_MAGIC 0x504C434B

/*  Translation functions  */

void ogfs_rgrp_save_in(ogfs_rgrp_save_t * rs, lm_lvb_t * lvb);
void ogfs_rgrp_save_out(ogfs_rgrp_save_t * rs, lm_lvb_t * lvb);

void ogfs_plock_elem_in(plock_element_t * pl, lm_lvb_t * lvb);
void ogfs_plock_elem_out(plock_element_t * pl, lm_lvb_t * lvb);
void ogfs_plock_jid_head_in(plock_jid_head_t * pl, lm_lvb_t * lvb);
void ogfs_plock_jid_head_out(plock_jid_head_t * pl, lm_lvb_t * lvb);
void ogfs_plock_head_in(plock_head_t * pl, lm_lvb_t * lvb);
void ogfs_plock_head_out(plock_head_t * pl, lm_lvb_t * lvb);

/*  Printing functions  */

void ogfs_rgrp_save_print(ogfs_rgrp_save_t * rs, int console);

#endif /* _LVB_H */
