/*
 *
 *    Copyright 1995-1999 Regents of the University of Minnesota
 *    Portions Copyright 2000-2001 Sistina Software, Inc.
 *
 *    This is free software released under the GNU General Public License.
 *    There is no warranty for this software.  See the file COPYING for
 *    details.
 *
 */
#ifndef _OGFS_IOCTL_H
#define _OGFS_IOCTL_H

#define _GFSC_(x)		(('G' << 8) | x)

/* Ioctls implemented */

#define OGFS_DEBUG_ON		_GFSC_(1)
#define OGFS_DEBUG_OFF		_GFSC_(2)
#define OGFS_DEBUG_DUMP		_GFSC_(3)

#define OGFS_PRINT_FRAG		_GFSC_(4)
#define OGFS_SHRINK		_GFSC_(5)

#define OGFS_PROF_DUMP		_GFSC_(6)

#define OGFS_OBYNUM		_GFSC_(7)
#define OGFS_GET_SUPER		_GFSC_(8)
#define OGFS_JREAD		_GFSC_(9)
#define OGFS_JWRITE		_GFSC_(10)

#define OGFS_LOCK_DUMP		_GFSC_(11)

#define OGFS_STATGFS		_GFSC_(12)
#define OGFS_STATRGRP		_GFSC_(13)

#define OGFS_RECLAIM_ONE	_GFSC_(14)
#define OGFS_RECLAIM_ALL	_GFSC_(15)

/*  Structure for profiling ioctl()  */

struct ogfs_profile {
	uint64 total_calls;
	uint64 total_micros;
	uint64 min_micros;
	uint64 max_micros;
};
typedef struct ogfs_profile ogfs_profile_t;

/*  Structure for jread/jwrite  */

struct ogfs_jio {
	uint64 jio_size;
	uint64 jio_offset;
	char *jio_data;
};
typedef struct ogfs_jio ogfs_jio_t;

/*  Structure for better OGFS-specific df  */

struct ogfs_usage {
	unsigned int block_size;
	uint64 total_blocks;
	uint64 free;
	uint64 used_dinode;
	uint64 free_dinode;
	uint64 used_meta;
	uint64 free_meta;
};
typedef struct ogfs_usage ogfs_usage_t;

/*  Structure for RGRP statistics info */
struct ogfs_rgrpstat {
	unsigned int rnum;
	struct ogfs_usage usage;
};
typedef struct ogfs_rgrpstat ogfs_rgrpstat_t;

#endif /* _OGFS_IOCTL_H */
