/*
 *
 *    Copyright 1995-1999 Regents of the University of Minnesota
 *    Portions Copyright 2001 Sistina Software, Inc.
 *
 *    This is free software released under the GNU General Public License.
 *    There is no warranty for this software.  See the file COPYING for
 *    details.
 *
 *    See the file AUTHORS for a list of contributors.
 *
 */
#ifndef _SUPER_H
#define _SUPER_H

int ogfs_check_sb(ogfs_sbd_t * sdp, ogfs_sb_t * sb, int silent);
int ogfs_read_sb(ogfs_sbd_t * sdp, ogfs_glock_t * gl, int silent);
int ogfs_do_upgrade(ogfs_sbd_t * sdp, ogfs_glock_t * gl_sb);

int ogfs_jindex_hold(ogfs_sbd_t * sdp, int wait);
void ogfs_jindex_release(ogfs_sbd_t * sdp);
void ogfs_clear_journals(ogfs_sbd_t * sdp);

void ogfs_compute_reserv(ogfs_sbd_t * sdp);

int ogfs_get_riinode(ogfs_sbd_t * sdp);
void ogfs_put_riinode(ogfs_sbd_t * sdp);
int ogfs_get_jiinode(ogfs_sbd_t * sdp);
void ogfs_put_jiinode(ogfs_sbd_t * sdp);

int ogfs_setup_dameth(ogfs_sbd_t * sdp);
int ogfs_update_datarget(ogfs_sbd_t * sdp, ogfs_ipreserv_t * res);

int ogfs_stat_ogfs(ogfs_sbd_t * sdp, ogfs_usage_t * usage, int interruptible);
int ogfs_stat_rgrp(ogfs_sbd_t * sdp, unsigned int rnum, ogfs_usage_t * usage);

/*  These are architecture specific functions
    Either implement them or stub them out in your arch_* directory.  */

void ogfs_mark_vsb(ogfs_sbd_t *sdp, int dirty);

struct super_block *ogfs_read_super(struct super_block *sb, void *, int);
extern struct super_operations ogfs_sops;

#endif /* _SUPER_H */
