/*
 *
 *    Copyright 1999-2001 Sistina Software, Inc.
 *    Portions Copyright 2003 Brian Jackson
 *    Portions Copyright 2003 The OpenGFS Project
 *
 *    This is free software released under the GNU General Public License.
 *    There is no warranty for this software.  See the file COPYING for
 *    details.
 *
 *    See the file AUTHORS for a list of contributors.
 *
 *    This file was maintained by:
 *      David C. Teigland <teigland@sistina.com>
 *
 */
#ifndef _CLUSTER_INFO_H
#define _CLUSTER_INFO_H

int init_cluster_info(memexp_t *moddata, uint32 ip);
void release_cluster_info(memexp_t *md);
int cid2jid(memexp_t *md, uint16 cid, uint32 *jid);
int cid2ipaddr(memexp_t *md, uint16 cid, uint32 *ip);
int jid2cid(memexp_t *md, uint32 jid, uint16 *cid);
int jid2nstomith(memexp_t *md, uint32 jid, uint32 *nstomith);
int get_stomith_desc(memexp_t *md, uint32 jid, struct cluster_stomith *st, int n);
int cluster_node_count(memexp_t *md);
int reread_cluster_info(memexp_t *md);
void show_cluster_info(memexp_t *md);

#endif /* _CLUSTER_INFO_H */
