/*
 *
 *    Copyright 2001 Sistina Software, Inc.
 *    Portions Copyright 2003 Brian Jackson
 *    Portions Copyright 2003 The OpenGFS Project
 *
 *    This is free software released under the GNU General Public License.
 *    There is no warranty for this software.  See the file COPYING for
 *    details.
 *
 *    See the file AUTHORS for a list of contributors.
 *
 *    This file was maintained by:
 *      Mike C Tilstra <conrad@sistina.com>
 *
 */

/*
 * All data structures and function params are in host byte order.
 * The contents of the buffers are opaque to this code. (so are the bids
 * for that matter.)
 */

#ifndef _DMEP_TCP_H
#define _DMEP_TCP_H

#include "memexp.h"
#include "ll_memexp.h"

extern struct ll_memexp_ops ll_dmep_tcp_ops;

/* my cheezy macros. */

#ifndef printe
#define printe(fmt, args...) printk(KERN_ERR "dmep_tcp: " fmt, ## args)
#endif
#ifndef printi
#define printi(fmt, args...) printk("dmep_tcp: " fmt, ## args)
#endif
#ifndef printdd
#define printdd(fmt, args...)
#endif

#endif /* _DMEP_TCP_H */
