/*
 *
 *    Copyright 1999-2001 Sistina Software, Inc.
 *    Portions Copyright 2003 Brian Jackson
 *    Portions Copyright 2003 The OpenGFS Project
 *
 *    This is free software released under the GNU General Public License.
 *    There is no warranty for this software.  See the file COPYING for
 *    details.
 *
 *    See the file AUTHORS for a list of contributors.
 *
 *    This file was maintained by:
 *      David C. Teigland <teigland@sistina.com>
 * 
 */

#ifndef _LOCK_STATE_DOT_H
#define _LOCK_STATE_DOT_H

int lsm_init(memexp_t * mep);
int lsm_shutdown(memexp_t * mep);
int lsm_lock(int action, me_lock_t * mlk, lsm_status_t * status, int force);
int lsm_mark_expired(memexp_t * mep, uint16 excid);
int lsm_reset_expired(memexp_t * mep, uint16 excid);
int lsm_drop_conversion(me_lock_t * mlk, lsm_status_t * status);
void lsm_lock_in(lsm_lock_t * lkp, char *buf);
void lsm_lock_out(lsm_lock_t * lkp, char *buf);
void lsm_lock_print(lsm_lock_t * lkp);
void lsm_check_state(me_lock_t * mlk, int state, int flags);

#endif /* _LOCK_STATE_DOT_H */
