/*
 *
 *    Copyright 2000-2001 Sistina Software, Inc.
 *    Portions Copyright 2003 Brian Jackson
 *    Portions Copyright 2003 The OpenGFS Project
 *
 *    This is free software released under the GNU General Public License.
 *    There is no warranty for this software.  See the file COPYING for
 *    details.
 *
 *    See the file AUTHORS for a list of contributors.
 *
 *    This file was maintained by:
 *      David C. Teigland <teigland@sistina.com>
 *
 */

#include "config.h"

#define EXTERN
#include "memexp.h"

#include <linux/module.h>
#include <linux/version.h>
#include <linux/init.h>
#include <linux/kmod.h>

extern struct lm_lockops memexp_ops;

static int __init
init_memexp(void)
{

	return lm_register_proto(&memexp_ops);
}

static void __exit
exit_memexp(void)
{
	lm_unregister_proto(&memexp_ops);
}

module_init(init_memexp);
module_exit(exit_memexp);

MODULE_DESCRIPTION("Memexp Locking Module");
MODULE_AUTHOR("The OpenGFS Project");
MODULE_LICENSE("GPL");
