/*                                                        -*- linux-c -*-
 *   _  _ ____ __ _ ___ ____ ____ __ _ _ _ _ | 
 * .  \/  |--| | \|  |  |--< [__] | \| | _X_ | s e c u r e  s y s t e m s
 *
 * .vt|ar5k - PCI/CardBus 802.11a WaveLAN driver for Atheros AR5k chipsets
 *
 * Copyright (c) 2002, .vantronix | secure systems
 *                     and Reyk Floeter <reyk@vantronix.net> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef VANTRONIX_ATHEROS_INIT_HEADER
#define VANTRONIX_ATHEROS_INIT_HEADER

#define INIT_CONFIG_STATUS 0x00000000
#define INIT_TOPS 0x00000008
#define INIT_ACKTOPS 0x00000008
#define INIT_RXNOPKT 0x00000008
#define INIT_RPGTO 0x00000000
#define INIT_TXNOPKT 0x00000000
#define INIT_BCON_CNTRL_REG 0x00000000
#define INIT_SLOT_TIME 0x00000168
#define INIT_SLOT_TIME_TURBO 0x000001e0 
#define INIT_ACK_CTS_TIMEOUT 0x04000400
#define INIT_ACK_CTS_TIMEOUT_TURBO 0x08000800
#define INIT_CWMIN 0xf
#define INIT_SH_RETRY 10
#define INIT_LG_RETRY 10
#define INIT_SSH_RETRY 32
#define INIT_SLG_RETRY 32
#define INIT_RETRY_LIMITS ((INIT_CWMIN << 20) | (INIT_SLG_RETRY<<14) | (INIT_SSH_RETRY<<8) |\
			  (INIT_LG_RETRY<<4) | INIT_SH_RETRY)
#define INIT_RETRY_FIELD 0x000000ff
#define INIT_SRETRY_FIELD 0x0000ff00
#define INIT_USEC 0x27
#define INIT_USEC_TURBO 0x4f
#define INIT_USEC_32 0x1f
#define INIT_TX_LATENCY	0x1f6
#define INIT_TRANSMIT_LATENCY ((INIT_TX_LATENCY<<14) | (INIT_USEC_32<<7) | INIT_USEC)
#define INIT_TRANSMIT_LATENCY_TURBO ((INIT_TX_LATENCY<<14) | (INIT_USEC_32<<7) | INIT_USEC_TURBO)
#define INIT_SIFS 0x230 
#define INIT_SIFS_TURBO	0x1E0 
#define INIT_DIFS 0x500 
#define INIT_DIFS_TURBO	0x5A0 
#define INIT_PROTOCOL_TIMERS ((INIT_DIFS<<11) | INIT_SIFS)
#define INIT_PROTOCOL_TIMERS_TURBO ((INIT_DIFS_TURBO<<11) | INIT_SIFS_TURBO)
#define MIN_TX_FIFO_THRESHOLD 0x1
#define MAX_TX_FIFO_THRESHOLD ((MAX_WLAN_BODY_SIZE / 64) + 1)
#define INIT_TX_FIFO_THRESHOLD MIN_TX_FIFO_THRESHOLD
#define	INIT_CFP_INTERVAL 0
#define INIT_NEXT_BEACON_TIME 0
#define INIT_TSF_CLOCK_LOW 0
#define INIT_DMA_BEACON_ALERT 0xffffffff
#define INIT_SW_BCON_ALERT 0xffffffff
#define INIT_NEXT_CFP_START 0xffffffff
#define INIT_BEACON_PERIOD 0xffff
#define INIT_TIM_OFFSET	0
#define INIT_BEACON_EN 0 
#define INIT_RESET_TSF 0
#define INIT_BEACON_CONTROL ((INIT_RESET_TSF<<24) | (INIT_BEACON_EN<<23) | \
			    (INIT_TIM_OFFSET<<16) | INIT_BEACON_PERIOD)
#define INIT_RSSI_THR 0x00000700 
#define INIT_ProgIFS 0x398 
#define INIT_ProgIFS_TURBO 0x3C0
#define INIT_EIFS 0xd70
#define INIT_EIFS_TURBO 0x1ae0
#define INIT_CARR_SENSE_EN 1
#define	INIT_PROTO_TIME_CNTRL ((INIT_CARR_SENSE_EN << 26) | (INIT_EIFS << 12) | (INIT_ProgIFS))
#define	INIT_PROTO_TIME_CNTRL_TURBO ((INIT_CARR_SENSE_EN << 26) | (INIT_EIFS_TURBO << 12) | \
				    (INIT_ProgIFS_TURBO))

const wlan_register_val_t vt_ar5k_register_init[] = {
	/* crete register */
	{ 0x00009800, 0x00000047 },
	{ 0x00009808, 0x00000000 },
	{ 0x0000980c, 0x09848ea6 },
	{ 0x00009810, 0x3d32e000 },
	{ 0x00009814, 0x0000076b },
	{ 0x0000981c, 0x00000000 },
	{ 0x00009820, 0x02020200 },
	{ 0x00009824, 0x00000e0e },
	{ 0x00009828, 0x0a020201 },
	{ 0x0000982c, 0x00036ffc },
	{ 0x00009830, 0x00000000 },
	{ 0x00009834, 0x00000e0e },
	{ 0x00009838, 0x00000007 },
	{ 0x0000983c, 0x00020100 },
	{ 0x00009840, 0x89630000 },
	{ 0x00009844, 0x1372169c },
	{ 0x00009848, 0x0018b633 },
	{ 0x0000984c, 0x1284613c },
	{ 0x00009850, 0x0de8b8e0 },
	{ 0x00009854, 0x00074859 },
	{ 0x00009858, 0x7e80beba },
	{ 0x0000985c, 0x313a665e },
	{ 0x00009860, 0x00001d08 },
	{ 0x00009864, 0x0001ce00 },
	{ 0x00009868, 0x409a4190 },
	{ 0x00009870, 0x0000000f },
	{ 0x00009874, 0x00000080 },
	{ 0x00009878, 0x00000004 },
	{ 0x0000987c, 0x00000018 },
	{ 0x00009900, 0x00000000 },
	{ 0x00009904, 0x00000000 },
	{ 0x00009908, 0x00000000 },
	{ 0x0000990c, 0x00800000 },
	{ 0x00009910, 0x00000003 },
  
	/* bb gain table */
	{ 0x00009b00, 0x00000000 },
	{ 0x00009b04, 0x00000020 },
	{ 0x00009b08, 0x00000010 },
	{ 0x00009b0c, 0x00000030 },
	{ 0x00009b10, 0x00000008 },
	{ 0x00009b14, 0x00000028 },
	{ 0x00009b18, 0x00000028 },
	{ 0x00009b1c, 0x00000004 },
	{ 0x00009b20, 0x00000024 },
	{ 0x00009b24, 0x00000014 },
	{ 0x00009b28, 0x00000034 },
	{ 0x00009b2c, 0x0000000c },
	{ 0x00009b30, 0x0000002c },
	{ 0x00009b34, 0x00000002 },
	{ 0x00009b38, 0x00000022 },
	{ 0x00009b3c, 0x00000012 },
	{ 0x00009b40, 0x00000032 },
	{ 0x00009b44, 0x0000000a },
	{ 0x00009b48, 0x0000002a },
	{ 0x00009b4c, 0x00000001 },
	{ 0x00009b50, 0x00000021 },
	{ 0x00009b54, 0x00000011 },
	{ 0x00009b58, 0x00000031 },
	{ 0x00009b5c, 0x00000009 },
	{ 0x00009b60, 0x00000029 },
	{ 0x00009b64, 0x00000005 },
	{ 0x00009b68, 0x00000025 },
	{ 0x00009b6c, 0x00000015 },
	{ 0x00009b70, 0x00000035 },
	{ 0x00009b74, 0x0000000d },
	{ 0x00009b78, 0x0000002d },
	{ 0x00009b7c, 0x00000003 },
	{ 0x00009b80, 0x00000023 },
	{ 0x00009b84, 0x00000013 },
	{ 0x00009b88, 0x00000033 },
	{ 0x00009b8c, 0x0000000b },
	{ 0x00009b90, 0x0000002b },
	{ 0x00009b94, 0x00000007 },
	{ 0x00009b98, 0x00000027 },
	{ 0x00009b9c, 0x00000017 },
	{ 0x00009ba0, 0x00000037 },
	{ 0x00009ba4, 0x0000000f },
	{ 0x00009ba8, 0x0000002f },
	{ 0x00009bac, 0x0000002f },
	{ 0x00009bb0, 0x0000002f },
	{ 0x00009bb4, 0x0000002f },
	{ 0x00009bb8, 0x0000002f },
	{ 0x00009bbc, 0x0000002f },
	{ 0x00009bc0, 0x0000002f },
	{ 0x00009bc4, 0x0000002f },
	{ 0x00009bc8, 0x0000002f },
	{ 0x00009bcc, 0x0000002f },
	{ 0x00009bd0, 0x0000002f },
	{ 0x00009bd4, 0x0000002f },
	{ 0x00009bd8, 0x0000002f },
	{ 0x00009bdc, 0x0000002f },
	{ 0x00009be0, 0x0000002f },
	{ 0x00009be4, 0x0000002f },
	{ 0x00009be8, 0x0000002f },
	{ 0x00009bec, 0x0000002f },
	{ 0x00009bf0, 0x0000002f },
	{ 0x00009bf4, 0x0000002f },
	{ 0x00009bf8, 0x0000002f },
	{ 0x00009bfc, 0x0000002f },

	/* rf gain table */
	{ 0x00009a00, 0x0000001d },
	{ 0x00009a04, 0x0000005d },
	{ 0x00009a08, 0x0000009d },
	{ 0x00009a0c, 0x000000dd },
	{ 0x00009a10, 0x0000011d },
	{ 0x00009a14, 0x00000021 },
	{ 0x00009a18, 0x00000061 },
	{ 0x00009a1c, 0x000000a1 },
	{ 0x00009a20, 0x000000e1 },
	{ 0x00009a24, 0x00000031 },
	{ 0x00009a28, 0x00000071 },
	{ 0x00009a2c, 0x000000b1 },
	{ 0x00009a30, 0x0000001c },
	{ 0x00009a34, 0x0000005c },
	{ 0x00009a38, 0x00000029 },
	{ 0x00009a3c, 0x00000069 },
	{ 0x00009a40, 0x000000a9 },
	{ 0x00009a44, 0x00000020 },
	{ 0x00009a48, 0x00000019 },
	{ 0x00009a4c, 0x00000059 },
	{ 0x00009a50, 0x00000099 },
	{ 0x00009a54, 0x00000030 },
	{ 0x00009a58, 0x00000005 },
	{ 0x00009a5c, 0x00000025 },
	{ 0x00009a60, 0x00000065 },
	{ 0x00009a64, 0x000000a5 },
	{ 0x00009a68, 0x00000028 },
	{ 0x00009a6c, 0x00000068 },
	{ 0x00009a70, 0x0000001f },
	{ 0x00009a74, 0x0000001e },
	{ 0x00009a78, 0x00000018 },
	{ 0x00009a7c, 0x00000058 },
	{ 0x00009a80, 0x00000098 },
	{ 0x00009a84, 0x00000003 },
	{ 0x00009a88, 0x00000004 },
	{ 0x00009a8c, 0x00000044 },
	{ 0x00009a90, 0x00000084 },
	{ 0x00009a94, 0x00000013 },
	{ 0x00009a98, 0x00000012 },
	{ 0x00009a9c, 0x00000052 },
	{ 0x00009aa0, 0x00000092 },
	{ 0x00009aa4, 0x000000d2 },
	{ 0x00009aa8, 0x0000002b },
	{ 0x00009aac, 0x0000002a },
	{ 0x00009ab0, 0x0000006a },
	{ 0x00009ab4, 0x000000aa },
	{ 0x00009ab8, 0x0000001b },
	{ 0x00009abc, 0x0000001a },
	{ 0x00009ac0, 0x0000005a },
	{ 0x00009ac4, 0x0000009a },
	{ 0x00009ac8, 0x000000da },
	{ 0x00009acc, 0x00000006 },
	{ 0x00009ad0, 0x00000006 },
	{ 0x00009ad4, 0x00000006 },
	{ 0x00009ad8, 0x00000006 },
	{ 0x00009adc, 0x00000006 },
	{ 0x00009ae0, 0x00000006 },
	{ 0x00009ae4, 0x00000006 },
	{ 0x00009ae8, 0x00000006 },
	{ 0x00009aec, 0x00000006 },
	{ 0x00009af0, 0x00000006 },
	{ 0x00009af4, 0x00000006 },
	{ 0x00009af8, 0x00000006 },
	{ 0x00009afc, 0x00000006 },
  
	/* fez register */
	{ 0x000098d4, 0x00000020 },
	{ 0x000098cc, 0x00000004 },
	{ 0x000098c8, 0x00060106 },
	{ 0x0000989c, 0x0000006d },
	{ 0x000098c0, 0x00000000 },
	{ 0x000098d0, 0x00000014 },
  
	{ 0xffffffff, 0x00000000 } /* end */
};

#endif
