/*                                                        -*- linux-c -*-
 *   _  _ ____ __ _ ___ ____ ____ __ _ _ _ _ | 
 * .  \/  |--| | \|  |  |--< [__] | \| | _X_ | s e c u r e  s y s t e m s
 *
 * .vt|ar5k - PCI/CardBus 802.11a WaveLAN driver for Atheros AR5k chipsets
 *
 * Copyright (c) 2002, .vantronix | secure systems
 *                     and Reyk Floeter <reyk@vantronix.net> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef VANTRONIX_TYPES_HEADER
#define VANTRONIX_TYPES_HEADER

/****** DEFINES ******/

#define __ATTRIB_PACK __attribute__ ((packed))

#define VINIT(args...) { printk("%s: ", dev_info); printk(args); }
#define VPRINT(args...) { printk("%s (%s): ", dev_info, dev->name); printk(args); }

#ifdef VT_DEBUG
#define VDEBUG(args...) printk(KERN_DEBUG "%s (%s) %s/%d: ", dev_info, dev->name, __FUNCTION__, __LINE__); printk(args)
#define VENTER() printk("%s: (enter) %s, %s line %i\n", dev_info, __FUNCTION__,__FILE__,__LINE__)
#define VEXIT() printk("%s: (exit) %s, %s line %i\n", dev_info, __FUNCTION__,__FILE__,__LINE__)
#else
#define VDEBUG(args...) /* do {} while (0) */
#define VENTER() /* do {} while (0) */
#define VEXIT() /* do {} while (0) */
#endif

/****** typdefs/structs ******/

/* ok, maybe this is ugly, but we need it :( */

#define VT_TASKLET struct tasklet_struct
#define VT_TASKLET_SCHEDULE(q) tasklet_schedule((q))
#define VT_TASKLET_INIT(q, f, d) \
do { memset((q), 0, sizeof(*(q))); (q)->func = (f); (q)->data = (d); } \
while (0)

typedef enum {
	TRUE=1, FALSE=0
} bool;

#define MAC2STR(a) (a)[0], (a)[1], (a)[2], (a)[3], (a)[4], (a)[5]
#define MACSTR "%02X:%02X:%02X:%02X:%02X:%02X"

#ifndef ARPHRD_IEEE80211
#define ARPHRD_IEEE80211 801
#endif

#ifndef ARPHRD_IEEE80211_PRISM
#define ARPHRD_IEEE80211_PRISM 802
#endif

#endif /* VANTRONIX_TYPES_HEADER */
