#ifndef _PPC_KEXEC_H
#define _PPC_KEXEC_H

#ifdef CONFIG_KEXEC
/*
 * KEXEC_SOURCE_MEMORY_LIMIT maximum page get_free_page can return.
 * I.e. Maximum page that is mapped directly into kernel memory,
 * and kmap is not required.
 *
 * Someone correct me if FIXADDR_START - PAGEOFFSET is not the correct
 * calculation for the amount of memory directly mappable into the
 * kernel memory space.
 */

/* Maximum physical address we can use pages from */
#define KEXEC_SOURCE_MEMORY_LIMIT (-1UL)
/* Maximum address we can reach in physical address mode */
#define KEXEC_DESTINATION_MEMORY_LIMIT (-1UL)

#define KEXEC_REBOOT_CODE_SIZE	4096

#ifdef CONFIG_GAMECUBE

#define KEXEC_GC_SAVED_STATE_FROM	(0x00000000)
#define KEXEC_GC_SAVED_STATE_TEMP_TO	(0x00f00000)
#define KEXEC_GC_SAVED_STATE_SIZE	(3*4096) /* bytes */

#undef  KEXEC_REBOOT_CODE_SIZE
#define KEXEC_REBOOT_CODE_SIZE		(4096+KEXEC_GC_SAVED_STATE_SIZE)

extern u32 kexec_gc_saved_state[];

#endif /* CONFIG_GAMECUBE */

#endif /* CONFIG_KEXEC */

#endif /* _PPC_KEXEC_H */
