/************************************* */
/* Rule Set Based Access Control       */
/* Author and (c) 1999-2004: Amon Ott  */
/* Helper functions for all parts      */
/* Last modified:  08/Mar/2004         */
/************************************* */

#ifndef __RSBAC_HELPER_H
#define __RSBAC_HELPER_H

#include <linux/types.h>
#include <rsbac/types.h>

char * inttostr(char[], int);

char * ulongtostr(char[], u_long);

/* convert u_long_long to binary string representation for MAC module */
char * u64tostrmac(char[], __u64);

#ifndef __KERNEL__
char * get_user_name(rsbac_uid_t user, char * name);

int rsbac_get_uid_name(rsbac_uid_t * uid, char * name, char * sourcename);

int rsbac_get_fullname(char * fullname, rsbac_uid_t uid);

static inline int rsbac_get_uid(rsbac_uid_t * uid, char * sourcename)
  {
    return rsbac_get_uid_name(uid, NULL, sourcename);
  }

/* covert u_long_long to binary string representation for log array */
char * u64tostrlog(char[], __u64);
/* and back */
__u64 strtou64log(char[], __u64 *);

/* convert u_long_long to binary string representation for MAC module */
/* and back */
__u64 strtou64mac(char[], __u64 *);

/* covert u_long_long to binary string representation for RC module */
char * u64tostrrc(char[], __u64);
/* and back */
__u64 strtou64rc(char[], __u64 *);

/* covert u_long_long to binary string representation for RC module / rights */
char * u64tostrrcr(char[], __u64);
/* and back */
__u64 strtou64rcr(char[], __u64 *);

/* ACL back */
__u64 strtou64acl(char[], __u64 *);
#endif

/* covert u_long_long to binary string representation for ACL module */
char * u64tostracl(char[], __u64);

char * longtostr(char[], long);

#ifdef __KERNEL__
int rsbac_get_owner(rsbac_uid_t * user_p);

int rsbac_put_user(unsigned char *, unsigned char *, int);

int rsbac_get_user(unsigned char *, unsigned char *, int);

extern inline void clear_user_buf(char * ubuf, int len);

char * rsbac_getname(const char *);

void rsbac_putname(const char *);

void rsbac_get_attr_error(char * , enum rsbac_adf_request_t);

void rsbac_ds_get_error(char * function, enum rsbac_attribute_t attr);
void rsbac_ds_set_error(char * function, enum rsbac_attribute_t attr);

#ifdef CONFIG_RSBAC_RC
void rsbac_rc_ds_get_error(char * function, enum rsbac_rc_item_t item);
void rsbac_rc_ds_set_error(char * function, enum rsbac_rc_item_t item);
#endif

#endif /* KERNEL */

#endif
