/************************************ */
/* Rule Set Based Access Control      */
/*                                    */
/* Author and (c) 1999-2004:          */
/*   Amon Ott <ao@rsbac.org>          */
/*                                    */
/* System Calls                       */
/*                                    */
/* Last modified: 13/Apr/2004         */
/************************************ */

#ifndef __RSBAC_SYSCALL_RSBAC_H
#define __RSBAC_SYSCALL_RSBAC_H

/* to keep include/asm-alpha/unistd.h happy */
//#define __LIBRARY__

#include <linux/unistd.h>
#include <rsbac/types.h>
#include <rsbac/syscalls.h>
//#define __NR_rsbac                      1270

#ifdef rsbac_syscall4
static inline rsbac_syscall4(int, rsbac,
                 int, dummy,
                 rsbac_version_t, version,
                 enum rsbac_syscall_t, call,
                 union rsbac_syscall_arg_t *, arg_p);
#define sys_rsbac(a,b,c) rsbac(0,a,b,c)

#else
#ifndef _syscall3
#define _syscall3(type,name,type1,arg1,type2,arg2,type3,arg3)           \
type                                                                    \
	name (type1 arg1, type2 arg2, type3 arg3)                               \
{                                                                       \
        register long dummy4 __asm__ ("out3");                          \
        register long dummy5 __asm__ ("out4");                          \
                                                                        \
        return __ia64_syscall((long) arg1, (long) arg2, (long) arg3,    \
                              dummy4, dummy5, __NR_##name);             \
}
#endif

static inline _syscall3(int, rsbac,
                 rsbac_version_t, version,
                 enum rsbac_syscall_t, call,
                union rsbac_syscall_arg_t *, arg_p);
#define sys_rsbac(a,b,c) rsbac(a,b,c)

#endif

#endif
